function Create(self)
	self.aimThreshold = 0;
	
	self.sensorRange = 500;
	self.target = nil;
	self.gunOffset = 13;
	
	self.maxSpeed = 20;
	self.acceleration = 0.2;
	self.Vel = Vector(0,0);
	self.RotAngle = 0;
	self.rotFactor = 0.2;
	
	self.gravTester = CreateMOPixel("Grav Tester");
	self.gravTester.Pos = Vector(self.Pos.X, self.Pos.Y - 3);
	self.gravTester.Vel = Vector(0,0);
	MovableMan:AddParticle(self.gravTester);
	self.gravAcc = 0;
end

function Update(self)
	if not(self:IsDead()) then
		if self.gravAcc == 0 then
			if self.gravTester.Vel.Y > 0 then
				self.gravAcc = self.gravTester.Vel.Y;
			end
		end

		local ownController = self:GetController();
		
		if not(ownController:IsPlayerControlled(-1)) then
			self:SetControllerMode(Controller.CIM_DISABLED, -1);
			ownController:SetState(Controller.WEAPON_FIRE, false);
			
			if self.target == nil then
				for actor in MovableMan.Actors do
					local distX = actor.Pos.X - self.Pos.X;
					local distY = actor.Pos.Y - (self.Pos.Y + self.gunOffset);
					local distance = math.sqrt(distX ^ 2 , distY ^ 2);
					if actor.Team ~= self.Team and distance <= self.sensorRange and not(actor:IsDead()) and actor.GetsHitByMOs then
						local found = SceneMan:CastMORay(Vector(self.Pos.X, self.Pos.Y + self.gunOffset), Vector(distX, distY), self.ID, 128, false, 2);
						local foundRoot = MovableMan:GetRootMOID(found);
						if foundRoot == actor.ID then
							local actorAngle = math.atan2(distY, distX) * -1;
							if actorAngle > math.pi / 2 or actorAngle < math.pi / -2 then
								ownController:SetState(Controller.MOVE_LEFT, true);
							else
								ownController:SetState(Controller.MOVE_RIGHT, true);
							end
							if actorAngle > math.pi / 2 then
								actorAngle = math.pi - actorAngle;
							end
							if actorAngle < math.pi / -2 then
								actorAngle = (math.pi * -1) - actorAngle;
							end
							self.target = actor;
							self:SetAimAngle(actorAngle);
							ownController:SetState(Controller.WEAPON_FIRE, true);
							
							break;
						end
					end
				end
			else
				if MovableMan:ValidMO(self.target) then
					local distX = self.target.Pos.X - self.Pos.X;
					local distY = self.target.Pos.Y - (self.Pos.Y + self.gunOffset);
					local distance = math.sqrt(distX ^ 2 , distY ^ 2);
					local found = SceneMan:CastMORay(Vector(self.Pos.X, self.Pos.Y + self.gunOffset), Vector(distX, distY), self.ID, 128, false, 2);
					local foundRoot = MovableMan:GetRootMOID(found);
					if self.target:IsDead() or foundRoot ~= self.target.ID or distance > self.sensorRange or not(self.target.GetsHitByMOs) then
						self.target = nil;
					else
						local targetVector = Vector(0,0);
						targetVector.X = self.target.Pos.X - self.Pos.X;
						targetVector.Y = self.target.Pos.Y - (self.Pos.Y + self.gunOffset);
						
						local targetAngle = math.atan2(targetVector.Y, targetVector.X) * -1;
						if targetAngle > math.pi / 2 or targetAngle < math.pi / -2 then
							ownController:SetState(Controller.MOVE_LEFT, true);
						else
							ownController:SetState(Controller.MOVE_RIGHT, true);
						end
						if targetAngle > math.pi / 2 then
							targetAngle = math.pi - targetAngle;
						end
						if targetAngle < math.pi / -2 then
							targetAngle = (math.pi * -1) - targetAngle;
						end
						self:SetAimAngle(targetAngle);
						ownController:SetState(Controller.WEAPON_FIRE, true);
					end
				else
					self.target = nil;
				end
			end
		end
		
		if self:GetAimAngle(false) > self.aimThreshold then
			ownController:SetState(Controller.WEAPON_FIRE, false);
			self:SetAimAngle(self.aimThreshold);
			self.target = nil;
		end
		
		if ownController:IsState(Controller.HOLD_LEFT) then
			self.Vel.X = self.Vel.X - self.acceleration;
			if self.Vel.X < -self.maxSpeed then
				self.Vel.X = -self.maxSpeed;
			end
		elseif ownController:IsState(Controller.HOLD_RIGHT) then
			self.Vel.X = self.Vel.X + self.acceleration;
			if self.Vel.X > self.maxSpeed then
				self.Vel.X = self.maxSpeed;
			end
		elseif self.Vel.X < 0 then
			self.Vel.X = self.Vel.X + self.acceleration;
			if self.Vel.X > 0 then
				self.Vel.X = 0;
			end
		elseif self.Vel.X > 0 then
			self.Vel.X = self.Vel.X - self.acceleration;
			if self.Vel.X < 0 then
				self.Vel.X = 0;
			end
		end
		if ownController:IsState(Controller.HOLD_UP) then
			self.Vel.Y = self.Vel.Y - self.acceleration;
			if self.Vel.Y < -self.maxSpeed then
				self.Vel.Y = -self.maxSpeed;
			end
		elseif ownController:IsState(Controller.HOLD_DOWN) then
			self.Vel.Y = self.Vel.Y + self.acceleration;
			if self.Vel.Y > self.maxSpeed then
				self.Vel.Y = self.maxSpeed;
			end
		elseif self.Vel.Y < 0 then
			self.Vel.Y = self.Vel.Y + self.acceleration;
			if self.Vel.Y > 0 then
				self.Vel.Y = 0;
			end
		elseif self.Vel.Y > 0 then
			self.Vel.Y = self.Vel.Y - self.acceleration;
			if self.Vel.Y < 0 then
				self.Vel.Y = 0;
			end
		end
		
		self.Vel.Y = self.Vel.Y - self.gravAcc;
		
		self.RotAngle = self.rotFactor * -(self.Vel.X / self.maxSpeed);
	end
end