function Create(self)
    --sheild values
    self.forceShieldRange = 45;
    self.maxHealth = 100;
    self.healthLeft = self.maxHealth;
    self.healthTimer = Timer();
    self.healthTime = 500;
    self.shieldAnimationTimer = Timer();
    self.shieldAnimationTime = 150;
    self.shieldPowerAnimationTimer = Timer();
    self.shieldPowerAnimationTime = 50;
    self.shieldPowerDurationTimer = Timer();
    self.shieldPowerDurationTime = 200;
    self.shieldImpactTime = 180;    
    
    --create metre
    self.metreOffset = Vector(6, -30);
    self.metre = CreateMOSParticle("InviHealthMetre");
    self.metre.Pos = self.Pos + self.metreOffset;
    MovableMan:AddParticle(self.metre);
    self.metre.Frame = self.metre.FrameCount - 1;    
    
    --shield state
    self.shieldState = "off";
end

function Update(self)

    -- shield state machine
    
    if self.shieldState == "off" then
        if UInputMan:KeyPressed(24) and self:IsPlayerControlled() then
            self.shieldState = "powerup"
            --setup the powerup image
            self.shieldPowerUp = CreateMOSParticle("MShield Power Rising");
            self.shieldPowerUp.TopFrame = self.shieldPowerUp.FrameCount - 2;         
            self.shieldPowerUp.Pos = self.Pos;
            self.shieldPowerUp.Frame = 0;
            MovableMan:AddParticle(self.shieldPowerUp);           
            --start the timer
            self.shieldPowerDurationTimer = Timer();
            self.shieldPowerAnimationTimer = Timer();
        end
        
    elseif self.shieldState == "powerup" then
        if self.shieldPowerDurationTimer:IsPastSimMS(self.shieldPowerDurationTime) then
            self.shieldState = "on"
            -- hide the powerup image
            MovableMan:RemoveParticle(self.shieldPowerUp);  
            -- show the shield
            self.shield = CreateMOSParticle("MShield");
            self.shield.TopFrame = self.shield.FrameCount - 2;
            self.shield.Pos = self.Pos;            
            MovableMan:AddParticle(self.shield);  
        end
        
        -- update every tick
        self.shieldPowerUp.Pos = self.Pos;
        self.shieldPowerUp:NotResting();
        self.shieldPowerUp.Age = 1;
        self.shieldPowerUp.ToSettle = false;
        self.shieldPowerUp.ToDelete = false;
        
        if self.shieldPowerAnimationTimer:IsPastSimMS(self.shieldPowerAnimationTime) then
            if self.shieldPowerUp.Frame < self.shieldPowerUp.TopFrame then
                self.shieldPowerAnimationTimer = Timer();
                self.shieldPowerUp.Frame = self.shieldPowerUp.Frame + 1;
            end
        end    
        
    elseif self.shieldState == "on" then 
        -- power down if they hit 'x' or we run out of health
        if (UInputMan:KeyPressed(24) and self:IsPlayerControlled()) or self.healthLeft <= 1 then
            self.shieldState = "powerdown"
            --hide the shield
            MovableMan:RemoveParticle(self.shield);  
            --setup the powerdown image
            self.shieldPowerDown = CreateMOSParticle("MShield Power Falling");
            self.shieldPowerDown.TopFrame = self.shieldPowerDown.FrameCount - 2;
            MovableMan:AddParticle(self.shieldPowerDown);           
            --start the timer
            self.shieldPowerDurationTimer = Timer();
        end
       
        -- update every tick
        self.shield.Pos = self.Pos;
        self.shield:NotResting();
        self.shield.Age = 1;
        self.shield.ToSettle = false;
        self.shield.ToDelete = false;
        
        if self.shieldAnimationTimer:IsPastSimMS(self.shieldAnimationTime) then
            if self.shield.Frame < self.shield.TopFrame then
                self.shieldAnimationTimer = Timer();
                self.shield.Frame = self.shield.Frame + 1;
            end
             
            if self.shield.Frame == self.shield.TopFrame then
                self.shield.Frame = 0;
            end
        end

    elseif self.shieldState == "powerdown" then
        if self.shieldPowerDurationTimer:IsPastSimMS(self.shieldPowerDurationTime) then
            self.shieldState = "off"
            -- hide the powerdown image
            MovableMan:RemoveParticle(self.shieldPowerDown);  
        end
        
        -- update every tick
        self.shieldPowerDown.Pos = self.Pos;
        self.shieldPowerDown:NotResting();
        self.shieldPowerDown.Age = 1;
        self.shieldPowerDown.ToSettle = false;
        self.shieldPowerDown.ToDelete = false;
        
        if self.shieldPowerAnimationTimer:IsPastSimMS(self.shieldPowerAnimationTime) then
            if self.shieldPowerDown.Frame < self.shieldPowerDown.TopFrame then
                self.shieldPowerAnimationTimer = Timer();
                self.shieldPowerDown.Frame = self.shieldPowerDown.Frame + 1;
            end
        end         
        
    end
        
    if self.shieldState == "on" then          
    
        for particle in MovableMan.Particles do
            if particle.HitsMOs and particle.Team ~= 0 and  particle.Sharpness > 1 then-- particle.PresetName ~= "Jet Pack Flame" and particle.PresetName ~= "Blue Plasma Spark" and particle.PresetName ~= "Blue Plasma Spark Harmless" and particle.PresetName ~= "Jet Pack Spark Harmless" and particle.PresetName ~= "Small Blue Blast Harmless" then
                local distx =  particle.Pos.X - self.Pos.X;
                local disty =  particle.Pos.Y - self.Pos.Y;
                local dist = math.sqrt(distx ^ 2 + disty ^ 2);
    
                if dist <= self.forceShieldRange then
                    local relvelx = particle.Vel.X - self.Vel.X;
                    local relvely = particle.Vel.Y - self.Vel.Y;
                    
                    if distx > 0 and relvelx < 0 then
                        AdjustVelocity(self, particle);
                    else
                        if distx < 0 and relvelx > 0 then
                            AdjustVelocity(self, particle);  
                        end
                    end    
                end
            end
        end        
    end
    
    if self.shieldState == "off" then
        AddHealth(self);
    end    
    
    --Update Metre   
    if MovableMan:ValidMO(self.metre) then
        self.metre.Pos = self.Pos + self.metreOffset;
        self.metre:NotResting();
        self.metre.Age = 1;
        self.metre.ToSettle = false;
        self.metre.ToDelete = false;
        
        self.metre.Frame = math.floor(self.metre.FrameCount / self.maxHealth * self.healthLeft );
    end
    
    if MovableMan:ValidMO(self.impact) then
        if self.shieldImpactTimer:IsPastSimMS(self.shieldImpactTime) then
            MovableMan:RemoveParticle(self.impact);
        end
        
        self.impact:NotResting();
        self.impact.Age = 1;
        self.impact.ToSettle = false;
        self.impact.ToDelete = false;
    end   
end

--Update Health
function AddHealth(self)
    if self.healthLeft < 0 then
        self.healthLeft = 0
    end
    
    if self.healthLeft > self.maxHealth then
        self.healthLeft = self.maxHealth
    end    
    
    if self.healthLeft < self.maxHealth then
        if self.healthTimer:IsPastSimMS(self.healthTime) then
            self.healthTimer = Timer();
            self.healthLeft = self.healthLeft + 5;
        end
    end
end

--Deflect Projectiles
function AdjustVelocity(self, particle)
    if self.healthLeft >= 1 then
        local absvelx = math.abs(particle.Vel.X);
        local absvely = math.abs(particle.Vel.Y);
        local healthLoss = (absvelx * absvely * particle.Mass) / 12
        self.healthLeft = self.healthLeft - healthLoss;
        
        particle.Vel.X = - ((self.healthLeft / self.maxHealth) * particle.Vel.X);
        self.impact = CreateAEmitter("MShield Wound Blast");
        self.impact.Pos = particle.Pos;
        MovableMan:AddParticle(self.impact);
        self.shieldImpactTimer = Timer();
    end
end

function Destroy(self)
    if MovableMan:ValidMO(self.metre) then
        self.metre.Lifetime = 1;
    end
    
    if MovableMan:ValidMO(self.shield) then
        self.shield.Lifetime = 1;
    end
    
    if MovableMan:ValidMO(self.shieldPowerUp) then
        self.shieldPowerUp.Lifetime = 1;
    end
    
    if MovableMan:ValidMO(self.shieldPowerDown) then
        self.shieldPowerDown.Lifetime = 1;
    end
end
